/* GtkDatabox - An extension to the gtk+ library
 * Copyright (C) 1998 - 2005  Dr. Roland Bock
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <gtkdatabox.h>

void
gtk_databox_bars_draw (GtkDatabox * box, GtkDataboxData * data)
{
   gint i = 0;
   gint count = 0;
   GdkSegment *segments = (GdkSegment *) box->points;
   gfloat axis = 0;

   axis = ((0 - box->top_left.y) * box->factor.y);
   for (i = 0; i < data->length; i++)
   {
      segments[i].x1 = segments[i].x2 =
	 (gint16) ((data->X[i] - box->top_left.x) * box->factor.x);
      segments[i].y1 = axis;
      segments[i].y2 =
	 (gint16) ((data->Y[i] - box->top_left.y) * box->factor.y);
   }
   count = data->length;
   for (i = 0; i < count; i += 65536)
   {
      gdk_draw_segments (box->pixmap, data->gc, segments,
			 MIN (65536, count - i));
   }
}
