/* GtkDatabox - An extension to the gtk+ library
 * Copyright (C) 1998 - 2005  Dr. Roland Bock
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <gtkdatabox.h>

void
gtk_databox_points_draw (GtkDatabox * box, GtkDataboxData * data)
{
   gint i = 0;
   gint count = 0;


   for (i = 0; i < data->length; i++)
   {
      box->points[i].x =
	 (gint16) ((data->X[i] - box->top_left.x) * box->factor.x);
      box->points[i].y =
	 (gint16) ((data->Y[i] - box->top_left.y) * box->factor.y);
   }
   count = data->length;
   if (data->size < 2)
   {
      /* More than 2^16 points will cause X IO error on most XServers
         (Hint from Paul Barton-Davis <pbd@Op.Net>) */
      for (i = 0; i < count; i += 65536)
      {
	 gdk_draw_points (box->pixmap, data->gc, box->points + i,
			  MIN (65536, count - i));
      }
   }
   else
   {
      for (i = 0; i < count; i++)
      {
	 /* Why on earth is there no gdk_draw_rectangles?? */
	 gdk_draw_rectangle (box->pixmap, data->gc, TRUE,
			     box->points[i].x - data->size / 2,
			     box->points[i].y - data->size / 2, data->size,
			     data->size);
      }
   }
}
